/* ---------------------------------------------------------------------
     "wcpp_dposv.h" - header for C++ wrapper for LAPACK DPOSV & DPOTRI
             Copyright (c) 2003-2005  by A. Miyoshi, Univ. Tokyo
--------------------------------------------------------------------- */
#ifndef _WCPP_DPOSV_H_
#define _WCPP_DPOSV_H_

#ifdef _WIN32
#define ENT_DPOSV DPOSV
#define ENT_DPOTRI DPOTRI
#else
#define ENT_DPOSV dposv_
#define ENT_DPOTRI dpotri_
#endif

extern "C" {
  void ENT_DPOSV(char &uplo, int &n, int &nrhs, double **a, int &lda,
   double **b, int &ldb, int &info);
  void ENT_DPOTRI(char &uplo, int &n, double **a, int &lda, int &info);
}

int lapack_dposv(char uplo, int n, int nrhs, double **a, int lda,
 double **b, int ldb);
int lapack_dpotri(char uplo, int n, double **a, int lda);

#endif
