/* ---------------------------------------------------------------------
     "wcpp_dsysv.h" - header for C++ wrapper for LAPACK DSYSV & DSYTRI
             Copyright (c) 2005-2007  by A. Miyoshi, Univ. Tokyo
--------------------------------------------------------------------- */

#ifndef _WCPP_DSYSV_H_
#define _WCPP_DSYSV_H_

#ifdef _WIN32
#define ENT_DSYSV DSYSV
#define ENT_DSYTRI DSYTRI
#else
#define ENT_DSYSV dsysv_
#define ENT_DSYTRI dsytri_
#endif

extern "C" {
  void ENT_DSYSV(char &uplo, int &n, int &nrhs, double **a, int &lda,
   int *ipiv, double **b, int &ldb, double *work, int &lwork, int &info);
  void ENT_DSYTRI(char &uplo, int &n, double **a, int &lda, int *ipiv,
   double *work, int &info);
}

int lapack_dsysv(char uplo, int n, int nrhs, double **a, int lda,
 int *ipiv, double **b, int ldb, double *work, int lwork);
int lapack_dsytri(char uplo, int n, double **a, int lda, int *ipiv,
 double *work);

/*
extern "C" {
  void ENT_DSBEV(char &jobz, char &uplo, int &n, int &kd, double **ab,
   int &ldab, double *w, double **z, int &ldz, double *work, int &info);
  void ENT_DPOSV(char &uplo, int &n, int &nrhs, double **a, int &lda,
   double **b, int &ldb, int &info);
  void ENT_DPOTRI(char &uplo, int &n, double **a, int &lda, int &info);
}

int lapack_dsbev(char jobz, char uplo, int n, int kd, double **ab,
 int ldab, double *w, double **z, int ldz, double *work);
int lapack_dposv(char uplo, int n, int nrhs, double **a, int lda,
 double **b, int ldb);
int lapack_dpotri(char uplo, int n, double **a, int lda);
*/

#endif
