# ========================================================================
#     build bex1D executables
#            Copyright (c) 2004-2008  by A. Miyoshi, Univ. Tokyo
# ========================================================================

# ----- names of C++ and Fortran compilers and options -----------------
# ----- suggested names of C++ and Fortran compilers
#  GNU compiler (Linux, Cygwin)     .. g++, g77
#               (Djgpp)             .. gpp, g77
#  Intel compilers for Linus        .. icc, ifort
#                  for Windows      .. icl, ifort
#  Unix (Solaris)                   .. CC,  f77
# ----- suggested optimization flags
#  Intel compilers for Windows      .. -O2
#  Others                           .. -O
# ----------------------------------------------------------------------

#CPCMP = g++ -O
#CPCMP = gpp -O
#CPCMP = icc -O
CPCMP = icl -O2
#CPCMP = CC -O

#F7CMP = g77 -O
#F7CMP = ifort -O
F7CMP = ifort -O2
#F7CMP = f77 -O

# ----- Operating System dependent -------------------------------------

#RM = rm -f
RM = del
#XO = o
XO = obj
#XA = a
XA = lib
TMPF =
# (usually needed ONLY for Djgpp)
#TMPF = bx1fitPlls bx1HRsol bx1VIBsol bx1S2HRsol

# ----- names of the LAPACK/BLAS library files -------------------------
#                           (to build a part of LAPACK/BLAS)
LPKSBE = lapack_dsbev.$(XA)
LPKPOS = lapack_dposv.$(XA)
LPKHBE = lapack_zhbev.$(XA)
#                           (to use pre-build LAPACK/BLAS)
#LPKSBE = wcpp_dsbev.$(XO)
#LPKPOS = wcpp_dposv.$(XO)
#LPKHBE = wcpp_zhbev.$(XO)

# ----- program to be used for linking ---------------------------------

LNKER = $(CPCMP)
#LNKER = $(F7CMP) -nofor_main

# ----- library options to the linker ----------------------------------
#                           (to build a part of LAPACK/BLAS)
#   GNU compiler                    .. -lg2c
#   Intel compilers for Linux       .. -cxxlib
#   Intel compiler for Windows      .. (null)
#   Unix (Solaris)                  .. -lfsu -lsunmath
#                           (to use pre-build LAPACK/BLAS)
#   linux g77-built BLAS/LAPACK     .. -llapack -lblas -lg2c
#   intel MKL                       .. (consult the MKL manual)
# ----------------------------------------------------------------------

#LLIBS = -lg2c
#LLIBS = -cxxlib
LLIBS =
#LLIBS = -lfsu -lsunmath
#LLIBS = -llapack -lblas -lg2c

# ===== no need to edit below in usual circumstances =====================

LOBJLL = bx1fitPlls.$(XO) libnumLls.$(XO) libbasIOstr.$(XO) $(LPKPOS)
HEADLL = libnumLls.h libbasIOstr.h lapack_dposv/wcpp_dposv.h

LOBJPS = bx1VIBsol.$(XO) libbx1PS.$(XO) libbx1com.$(XO) libbasIOstr.$(XO) $(LPKSBE)
HEADPS = libbx1PS.h libbx1com.h libbasIOstr.h lapack_dsbev/wcpp_dsbev.h

LOBJFS = bx1HRsol.$(XO) libbx1FS.$(XO) libbx1com.$(XO) libbasIOstr.$(XO) $(LPKHBE)
HEADFS = libbx1FS.h libbx1com.h libbasIOstr.h lapack_zhbev/wcpp_zhbev.h

LOBJCP2 = bx1S2HRsol.$(XO) libbx1CP2.$(XO) libbx1com.$(XO) libbasIOstr.$(XO) $(LPKSBE)
HEADCP2 = libbx1CP2.h libbx1com.h libbasIOstr.h lapack_dsbev/wcpp_dsbev.h

all: bx1fitPlls bx1HRsol bx1VIBsol bx1S2HRsol

bx1fitPlls : $(LOBJLL)
	$(LNKER) $(LOBJLL) $(LLIBS) -o bx1fitPlls

bx1VIBsol : $(LOBJPS)
	$(LNKER) $(LOBJPS) $(LLIBS) -o bx1VIBsol

bx1HRsol : $(LOBJFS)
	$(LNKER) $(LOBJFS) $(LLIBS) -o bx1HRsol

bx1S2HRsol : $(LOBJCP2)
	$(LNKER) $(LOBJCP2) $(LLIBS) -o bx1S2HRsol

bx1fitPlls.$(XO) : bx1fitPlls.cc bx1fitPlls.h $(HEADLL)
	$(CPCMP) -c bx1fitPlls.cc

bx1VIBsol.$(XO) : bx1VIBsol.cc bx1VIBsol.h $(HEADPS)
	$(CPCMP) -c bx1VIBsol.cc

bx1HRsol.$(XO) : bx1HRsol.cc bx1HRsol.h $(HEADFS)
	$(CPCMP) -c bx1HRsol.cc

bx1S2HRsol.$(XO) : bx1S2HRsol.cc bx1S2HRsol.h $(HEADCP2)
	$(CPCMP) -c bx1S2HRsol.cc

libnumLls.$(XO) : libnumLls.cc $(HEADLL)
	$(CPCMP) -c libnumLls.cc

libbx1PS.$(XO) : libbx1PS.cc $(HEADPS)
	$(CPCMP) -c libbx1PS.cc

libbx1FS.$(XO) : libbx1FS.cc $(HEADFS)
	$(CPCMP) -c libbx1FS.cc

libbx1CP2.$(XO) : libbx1CP2.cc $(HEADCP2)
	$(CPCMP) -c libbx1CP2.cc

libbx1com.$(XO) : libbx1com.cc libbx1com.h libbasIOstr.h
	$(CPCMP) -c libbx1com.cc

libbasIOstr.$(XO) : libbasIOstr.cc libbasIOstr.h
	$(CPCMP) -c libbasIOstr.cc

lapack_dsbev.a : lapack_dsbev/*.f lapack_dsbev/wcpp_dsbev.cc lapack_dsbev/wcpp_dsbev.h
	cd lapack_dsbev; \
	$(F7CMP) -c *.f; \
	$(CPCMP) -c wcpp_dsbev.cc; \
	ar cr ../$(LPKSBE) *.$(XO); \
	$(RM) *.$(XO); \
	cd ..

lapack_dsbev.lib : lapack_dsbev/*.f lapack_dsbev/wcpp_dsbev.cc lapack_dsbev/wcpp_dsbev.h
	cd lapack_dsbev
	$(F7CMP) -c *.f
	$(CPCMP) -c wcpp_dsbev.cc
	lib /OUT:..\$(LPKSBE) *.$(XO)
	$(RM) *.$(XO)
	cd ..

wcpp_dsbev.o : lapack_dsbev/wcpp_dsbev.cc lapack_dsbev/wcpp_dsbev.h
	cd lapack_dsbev; \
	$(CPCMP) -c wcpp_dsbev.cc -o ../wcpp_dsbev.o; \
	cd ..

wcpp_dsbev.obj : lapack_dsbev/wcpp_dsbev.cc lapack_dsbev/wcpp_dsbev.h
	cd lapack_dsbev
	$(CPCMP) -c wcpp_dsbev.cc -o ..\wcpp_dsbev.obj
	cd ..

lapack_dposv.a : lapack_dposv/*.f lapack_dposv/wcpp_dposv.cc lapack_dposv/wcpp_dposv.h
	cd lapack_dposv; \
	$(F7CMP) -c *.f; \
	$(CPCMP) -c wcpp_dposv.cc; \
	ar cr ../$(LPKPOS) *.$(XO); \
	$(RM) *.$(XO); \
	cd ..

lapack_dposv.lib : lapack_dposv/*.f lapack_dposv/wcpp_dposv.cc lapack_dposv/wcpp_dposv.h
	cd lapack_dposv
	$(F7CMP) -c *.f
	$(CPCMP) -c wcpp_dposv.cc
	lib /OUT:..\$(LPKPOS) *.$(XO)
	$(RM) *.$(XO)
	cd ..

wcpp_dposv.o : lapack_dposv/wcpp_dposv.cc lapack_dposv/wcpp_dposv.h
	cd lapack_dposv; \
	$(CPCMP) -c wcpp_dposv.cc -o ../wcpp_dposv.o; \
	cd ..

wcpp_dposv.obj : lapack_dposv/wcpp_dposv.cc lapack_dposv/wcpp_dposv.h
	cd lapack_dposv
	$(CPCMP) -c wcpp_dposv.cc -o ..\wcpp_dposv.obj
	cd ..

lapack_zhbev.a : lapack_zhbev/*.f lapack_zhbev/wcpp_zhbev.cc lapack_zhbev/wcpp_zhbev.h
	cd lapack_zhbev; \
	$(F7CMP) -c *.f; \
	$(CPCMP) -c wcpp_zhbev.cc; \
	ar cr ../$(LPKHBE) *.$(XO); \
	$(RM) *.$(XO); \
	cd ..

lapack_zhbev.lib : lapack_zhbev/*.f lapack_zhbev/wcpp_zhbev.cc lapack_zhbev/wcpp_zhbev.h
	cd lapack_zhbev
	$(F7CMP) -c *.f
	$(CPCMP) -c wcpp_zhbev.cc
	lib /OUT:..\$(LPKHBE) *.$(XO)
	$(RM) *.$(XO)
	cd ..

wcpp_zhbev.o : lapack_zhbev/wcpp_zhbev.cc lapack_zhbev/wcpp_zhbev.h
	cd lapack_zhbev; \
	$(CPCMP) -c wcpp_zhbev.cc -o ../wcpp_zhbev.o; \
	cd ..

wcpp_zhbev.obj : lapack_zhbev/wcpp_zhbev.cc lapack_zhbev/wcpp_zhbev.h
	cd lapack_zhbev
	$(CPCMP) -c wcpp_zhbev.cc -o ..\wcpp_zhbev.obj
	cd ..

clean:
	$(RM) *.$(XO) *.$(XA) $(TMPF)

